# Credits

This page lists all the individual contributions to the project by their author.

- **Belonit (Gluk-v48)**:
  - Disable empty spawn positions
  - `gamemd.exe` icon customization
  - Full-color non-paletted PCX support
  - Initial SpySat, BigGap, TransactMoney warheads
  - PCX Loading Screen support
  - Custom DiskLaser radius
  - Extended tooltips
  - Building upgrades enhancement
  - Option to hide health bar
  - Sidebar.GDIPosition
  - Help with CellSpread
  - Blowfish.dll-related errors fix
  - Zero size map previews fix
  - Semantic locomotor aliases
  - Shield logic
  - Non-ASCII input fix
  - Building Placement Preview Adjustment
  - Check for Changelog/Documentation/Credits in Pull Requests
  - Fix position and layer of info tip and reveal production cameo on selected building
  - Fix a glitch related to incorrect target setting for missiles
  - Ability to disable shadow for debris & meteor animations
- **Kerbiter (Metadorius)**:
  - Building upgrades enhancement
  - Extended tooltips
  - Selection priority filtering
  - `TurretOffset` enhancement
  - Customizable ore spawners
  - Select next idle harvester hotkey
  - Interceptor enhancement
  - Zero size map previews fix
  - LaserTrails port and rework
  - Laser graphics fixes
  - Recursive transport killer fix
  - Custom locomotors example implementation and piggybacking test warheads
  - Jumpjet initial facing fix
  - Migration utility
  - GitHub Actions setup
  - Official docs
  - VSCode configs
  - Code style
  - Customizable ElectricBolt Arcs
  - Ability to disable shadow for debris & meteor animations
- **Uranusian (Thrifinesma)**:
  - Mind Control enhancement
  - Custom warhead splash list
  - Harvester counter
  - Spawns promotion
  - Shield logic
  - Multiple death fix
  - Customizable missing cameo
  - Cameo sorting priority
  - Tab hotkey placement fix
  - Producing progress indicators
  - Custom ore gathering anim
  - `NoManualMove`
  - Weapon target house filtering
  - `DeathWeapon` fix
  - Re-enable obsolete `JumpjetControls`
  - `AITrigger` Building Upgrades support
  - Wall-Gate links
  - Ability for deployed infantry to use both weapons
  - Observer PCX loading screen
  - Official CN docs
- **secsome (SEC-SOME)**:
  - Debug info dump hotkey
  - Refactoring & porting of Ares helper code
  - Disguise removal warhead
  - Mind Control removal warhead
  - Mind Control enhancement
  - Shields logic help
  - `AnimList.PickRandom`
  - `MoveToCell` fix
  - Unlimited waypoints
  - `Build At` trigger action buildup anim fix
  - Undeploy building into a unit plays `EVA_NewRallyPointEstablished` fix
  - Custom ore gathering anim
  - `TemporalClass` related crash
  - Retry dialog on mission failure
  - Default disguise for individual InfantryTypes
  - PowerPlant Enhancer
  - SaveGame Trigger Action
  - QuickSave command
  - Numeric variables
  - Custom gravity for projectiles
  - Retint map actions bugfix
  - Sharpnel enhancement
  - Vanilla map preview reading bugfix
  - Customizable tooltip background
  - Parts of Ares calling code
- **Otamaa (Fahroni, BoredEXE)**:
  - Help with CellSpread
  - Ported and fixed custom RadType code
  - Togglable ElectricBolt bolts
  - Customizable Chrono Locomotor properties per TechnoClass
  - Building Placement Preview
  - `DebrisMaximums` fixes
  - Anim-to-Unit
  - `NotHuman` anim sequences improvements
  - Customizable `OpenTopped` Properties
  - Hooks for ScriptType Actions 92 & 93
  - Ore stage threshold for `HideIfNoOre`
  - Occupied building `MuzzleFlashX` bugfix
  - `EnemyUIName=` for other TechnoTypes
  - TerrainType `DestroyAnim` & `DestroySound`
  - Laser trails for VoxelAnims
  - MakeInfantry logic on BombClass bugfix
  - Debris & meteor impact behaviour settings
  - Upgrade logic to allow altering of SpySat status
  - Ares detection and integration
  - Help with custom locomotors
  - Extension class optimization
- **FS-21**:
  - Dump Object Info enhancements
  - `Powered.KillSpawns`
  - `Spawner.LimitRange`
  - Majority of ScriptType actions
  - MC deployer fixes
  - Help with docs
  - Automatic Passenger Deletion logic
  - `Fire SW At Location/Waypoint` Trigger Action
  - Kill Object Automatically logic prototype
  - Customizable resource storage
  - Override uncloaked underwater attack behavior
  - AI Aircraft docks fix
  - Shared ammo logic
  - Customizable FLH when infantry is prone or deployed
  - Initial strength for cloned infantry
- **Starkku**:
  - Misc. minor bugfixes & improvements
  - AI script actions:
    - Chronoshift to Enemy Base
  - Warhead shield penetration & breaking
  - Strafing aircraft weapon customization
  - Vehicle `DeployFire` fixes/improvements
  - Stationary VehicleTypes
  - Burst logic improvements
  - TechnoType auto-firing weapons
  - Secondary weapon fallback customization
  - Weapon target type filtering
  - `AreaFire` targeting customization
  - `CreateUnit` improvements
  - Attached animation & jumpjet unit layer customization
  - `IsSimpleDeployer` improvements
  - Shield modification warheads
  - Warhead decloaking toggle
  - Warp(In/Out)Weapon
  - Grinder improvements / additions
  - Attached animation position customization
  - Critical hit logic additions
  - Aircraft & jumpjet speed modifiers fix
  - Local warhead screen shaking
  - Vehicle custom palette fix
  - Feedback weapon
  - TerrainType & ore minimap color customization
  - Laser fixes & improvements
  - Mind control indicator animation cloak fix
  - Warhead / Play animation trigger animation owner fix
  - Nuke carrier & payload Bright fix
  - Display damage numbers hotkey command
  - TransactMoney.Display
  - Building-provided self-heal customization
  - AI deploy script DeploysInto fix
  - Passable & buildable-upon TerrainTypes
  - Automatic passenger owner change toggle
  - Interceptor improvements
  - OpenTopped transport behaviour customizations
  - Animation damage / weapon improvements
  - Warhead self-damaging toggle
  - Trailer animation owner inheritance
  - Warhead detonation on all objects on map
  - Animated TerrainTypes extension
  - Exploding unit passenger killing customization
  - Railgun particle target coordinate fix
  - Building target coordinate offset fix
  - Warhead / weapon detonation at superweapon target cell
  - Cloaked & disguised objects displaying to observers
  - Building airstrike target eligibility customization
  - IvanBomb detonation & image display centered on buildings
  - Customizable ROF random delay
  - BibShape drawing during buildup fix
  - Spawner spawn delay customization
  - Cluster scatter distance customization
  - FlakScatter distance customization
  - Debris & meteor impact behaviour settings
  - Custom warhead debris animations
  - Attached particle system for animations
  - Removal of hardcoded AA & Gattling weapon selection restrictions
  - Projectile obstacle logic additions
  - `AnimList` on zero damage Warheads toggle
  - Additions to automatic passenger deletion
  - Buildings considered as vehicles
  - TechnoType target evaluation map zone check behaviour customization
  - CanC4 damage rounding fix & toggle
  - Option to center pause menu background
  - Disguise logic improvements
  - Custom insignias
  - `ZShapePointMove` buildup toggle
  - `UndeploysInto` building selling buildup sequence length customization
  - AI naval vehicle production fix
  - Crushing tilt and slowdown customization
  - Extra warhead detonations on weapons
  - Chrono sparkle animation display customization and improvements
  - PipScale pip size & ammo pip frame customization
  - Extension class optimization
  - Additional sync logging
  - `Arcing` elevation inaccuracy fix
  - `EMPulseCannon` projectile gravity fix
  - Custom palette support for wall overlays
  - Warhead animation improvements
  - Reloading ammo in transports
  - Straight projectile trajectory additions
  - Airstrike & spy plane fixed spawn distance & height
  - Negative damage `Verses/PercentAtMax` toggle
  - Misc. singleplayer mission improvements
  - Weapon effect obstacle interaction fix
  - Fire particle rotation coordinate adjust toggle
  - `AmbientDamage` warhead & main target ignore customization
  - Projectile return weapon
  - Aircraft landing / docking direction
  - `DeploysInto` cursor desync fix
  - Minor crate logic improvements
  - Custom tint effects
  - Revenge weapons
  - AttachEffect
- **Morton (MortonPL)**:
  - `XDrawOffset` for animations
  - Shield passthrough & absorption
  - Building `LimboDelivery` logic
  - Fix for `Image` in art rules
  - Power delta counter
  - Super Weapons launching other Super Weapons
  - SpyEffects expansion, launching Super Weapons on building infiltration
  - Real time timers
  - Default campaign game speed override and custom campaign game speed FPS
  - Including INI files and inheriting INI sections
  - Ares detection and integration
  - TechnoType conversion warhead & superweapon
  - Unlimited skirmish colors
  - Show designator & inhibitor range
  - Dump variables to file on scenario end / hotkey
  - "House owns TechnoType" and "House doesn't own TechnoType" trigger events
  - Help with docs
- **ChrisLv_CN** (work relicensed under [following permission](https://github.com/Phobos-developers/Phobos/blob/develop/images/ChrisLv-relicense.png)):
   - General assistance
   - Interceptor logic prototype
   - LaserTrails prototype
   - Laser fixes prototype
- **Trsdy**
   - Preserve IronCurtain status upon DeploysInto/UndeploysInto
   - Several jumpjet fixes:
      - Facing towards target even if not omni-firing
      - Turret direction in idle state fix
      - Sensor fix
      - Allow to tilt regardless of TiltCrashJumpjet
      - Forbid firing when crashing
   - OmniFire.TurnToTarget
   - Object Self-destruction logic
   - Misc vanilla suicidal behavior fix
   - Post-type-conversion update
   - Units retaining orders after changing ownership bugfix
   - Several fixes and dehardcode related to building selling/undeploying:
     - Building `EVA_StructureSold` and `SellSound` dehardcode
     - Restore `EVA_StructureSold` for buildings with `UndeploysInto`
     - Redeployable MCV in campaigns
     - Allow buildings with `UndeploysInto` to be sold if `Unsellable=no` even if not conyard
     - Trigger actions that allow/forbid MCV to redeploy in game
   - `AlternateFLH` of vehicles in `OpenTopped` transport.
   - Slaves' house customization when owner is killed
   - Trigger Action spawned team IFV/Opentopped logic fix
   - Singleplayer Campaign AI's base node/SW-delivered/trigger action 125-delivered structures' auto-repairability dehardcode
   - Power delta counter : blackout indication mark
   - Harvester counter
   - Income money string indication upon ore dump
   - Warhead superweapon launch logic
   - TechnoType conversion placeholder
   - "Shield is broken" trigger event
   - RadialIndicator observer visibility
   - Cloaked objects from allies displaying to player in singleplayer campaigns
   - Skip `NaturalParticleSystem` displaying from in-map pre-placed structures
   - Random crate generation limited to land option, optimization for crates' random sampling
   - `ImmuneToCrit` for shields
   - Forbidding parallel AI queues by type
   - The option to allow DieSound/VoiceDie being played when grinding
   - Allow iron-curtain effects on infantries
   - Break the mindcontrol link when capturing a mind-controlled building with engineer
   - Remove sound events when mind-controlled vehicles deploy into buildings or when buildings considered as vehicles get captured
   - Building LightSource tint S/L fix
   - Permanent healthbar display on units targeted by temporal weapons fix
   - Powered anims on buildings cease playing upon capture by different house fix
   - TechnoType conversion placeholder
   - TechnoType conversion upon ownership change
   - EIP 00529A14 crash fix on Linux
   - Teleport timer reset after load game fix
   - Teleport, Tunnel and Fly loco visual tilt fix
   - Turret/Barrel/NoSpawnAlt/Multi-section voxel shadow, dynamic voxel shadow
   - Skip units' turret rotation and jumpjets' wobbling under EMP
   - Droppod properties dehardcode
   - Waypoint entering building together with engineer/agent bug fix
   - Skippable game save on scenario start
   - Skip rally point line drawing when undeploying a building
   - Misc code refactor & maintenance, CN doc fixes, bugfixes
- **FlyStar**
   - Campaign load screen PCX support
   - New condition for automatic self-destruction logic when TechnoTypes exist/don't exist
- **NetsuNegi**
   - Forbidding parallel AI queues by type
   - Jumpjet crash speed fix when crashing onto building
- **Apollo** - Translucent SHP drawing patches
- **ststl**
   - Customizable ShowTimer priority of superweapons
   - Iron Curtain effects customization on infantries and organic units
   - Use `CustomPalette` for animations with `Tiled=yes`
   - Unlimited `AlternateFLH` entries
- **TwinkleStar**
  - Custom slaves free sound
  - Jumpjet crash rotation control
  - Vehicle voxel turret shadows & body multi-section shadows
  - `TurretOffset` support for SHP vehicles
- **Fryone**
  - Customizable ElectricBolt Arcs
  - Sound entry on unit's creation
  - Auto-deploy/Deploy block on ammo change
  - Flashing Technos on selecting
- **ZivDero**
  - Allow giving ownership of buildings to players in Skirmish and MP using <Player @ A-H>
  - Re-enable the Veinhole Monster and Weeds from TS
  - Recreate the weed-charging of SWs like the TS Chemical Missile
  - Allow to change the speed of gas particles
- **Ares developers**
  - YRpp and Syringe which are used, save/load, project foundation and generally useful code from Ares
  - unfinished RadTypes code
  - prototype deployer fixes
  - Superweapon launch site & availability code
  - AI vehicle production update code
  - parts of TechnoType conversion placeholder code
- **ststl, FlyStar, Saigyouji, JunJacobYoung** - Digital Display
- **SukaHati (Erzoid)** - Minimum interceptor guard range
- **E1 Elite** - TileSet 255 and above bridge repair fix
- **AutoGavy** - interceptor logic, Warhead critical hit logic
- **Chasheen (Chasheenburg)** - CN docs help
- **tomsons26** - all-around help, assistance and guidance in reverse-engineering, YR binary mappings
- **CCHyper** - all-around help, current project logo, assistance and guidance in reverse-engineering, YR binary mappings, custom locomotors example implementation
- **AlexB** - Original FlyingStrings implementation
- **Joshy** - Original FlyingStrings implementation
- **CnCVK** - Original custom locomotors experiment
- **ZΞPHYɌUS** - win/lose themes code
- **Neargye (Daniil Goncharov)** - [nameof library](https://github.com/Neargye/nameof) (MIT)
- **ayylmao** - help with docs, extensive and thorough testing
- **SMxReaver** - help with docs, extensive and thorough testing
- **4SG** - help with docs
- **thomassneddon** - general assistance
- **Xkein** - general assistance, YRpp edits
- **mevitar** - honorary shield tester *triple* award
- **Damfoos** - extensive and thorough testing
- **Dmitry Volkov** - extensive and thorough testing
- **Rise of the East community** - extensive playtesting of in-dev features
